<?php

namespace FiloBlu\Pos\Block\Adminhtml\Config\Form\Field;

use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;
use Magento\Backend\Block\Template\Context;

class PosDeviceEnabler extends Field
{

    protected $deviceHelper;

    public function __construct(
        \FiloBlu\Pos\Helper\Pos $deviceHelper,
        Context $context,
        array $data = []
    ) {
        $this->deviceHelper = $deviceHelper;
        parent::__construct($context, $data);
    }

    /**
     * {@inheritdoc}
     */
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('config/form/field/device_enabler.phtml');
        }

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function render(AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();

        return parent::render($element);
    }

    /**
     * {@inheritdoc}
     */
    protected function _getElementHtml(AbstractElement $element)
    {
        return $this->_toHtml();
    }

    public function getDevices() {
        return $this->deviceHelper->retrieveDeviceList();
    }


    /**
     * Get validation URL for given module.
     *
     * @return string
     */
    public function getEnablerUrl($deviceId)
    {
        return $this->getUrl('filoblupos_be/posmode/enable/device/' . $deviceId);
    }
}
