<?php

namespace FiloBlu\Pos\Block\Adminhtml\Config\Form\Field;

use Magento\Config\Block\System\Config\Form\Field;
use Magento\Framework\Data\Form\Element\AbstractElement;
use Magento\Backend\Block\Template\Context;

class PosVisibilityEnabler extends Field
{

    protected $deviceHelper;

    public function __construct(
        \FiloBlu\Pos\Helper\Pos $deviceHelper,
        Context $context,
        array $data = []
    ) {
        $this->deviceHelper = $deviceHelper;
        parent::__construct($context, $data);
    }

    /**
     * {@inheritdoc}
     */
    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('config/form/field/visibility_enabler.phtml');
        }

        return $this;
    }

    /**
     * {@inheritdoc}
     */
    public function render(AbstractElement $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();

        return parent::render($element);
    }

    /**
     * {@inheritdoc}
     */
    protected function _getElementHtml(AbstractElement $element)
    {
        return $this->_toHtml();
    }

    /**
     * Generate button html
     *
     * @return string
     */
    public function getButtonsHtml()
    {
        $enableUrl = $this->getUrl('filoblupos_be/posmode/enable/visibility/1');
        $disableUrl = $this->getUrl('filoblupos_be/posmode/enable/visibility/0');

        $buttons = [];
        $button = $this->getLayout()->createBlock(
            'Magento\Backend\Block\Widget\Button'
        )->setData(
            [
                'id' => 'filoblupos_visibility_enable_button',
                'label' => __('Enable POS in this browser'),
                'onclick' => 'javascript:window.open("' . $enableUrl . '", "_blank")',
            ]
        );
        $buttons[] = $button->toHtml();

        $button = $this->getLayout()->createBlock(
            'Magento\Backend\Block\Widget\Button'
        )->setData(
            [
                'id' => 'filoblupos_visibility_disable_button',
                'label' => __('Disable POS in this browser'),
                'onclick' => 'javascript:window.open("' . $disableUrl . '", "_blank")',
            ]
        );
        $buttons[] = $button->toHtml();

        return $buttons;
    }
}
