<?php


namespace FiloBlu\Pos\Controller\Posmode;

use Magento\Framework\Stdlib\Cookie\CookieMetadataFactory;
use Magento\Framework\Stdlib\CookieManagerInterface;

class Enable extends \Magento\Framework\App\Action\Action
{

    const POS_VISIBILITY_COOKIE_NAME = 'filoblu_pos_mode';
    const POS_ID_COOKIE_NAME = 'filoblu_pos_id';
    const COOKIE_DURATION = 86400 * 90; // 90 days

    /**
     * @var CookieManagerInterface
     */
    protected $cookieManager;

    /**
     * @var CookieMetadataFactory
     */
    protected $cookieMetadataFactory;

    /**
     * Enable constructor.
     * @param CookieManagerInterface $cookieManager
     * @param CookieMetadataFactory $cookieMetadataFactory
     */
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        CookieManagerInterface $cookieManager,
        CookieMetadataFactory $cookieMetadataFactory
    ) {
        $this->cookieManager = $cookieManager;
        $this->cookieMetadataFactory = $cookieMetadataFactory;
        parent::__construct($context);
    }

    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        if ($this->getRequest()->getParam('device') != NULL) {

            $deviceHash = $this->getRequest()->getParam('device');

            $metadata = $this->cookieMetadataFactory
                ->createPublicCookieMetadata()
                ->setDuration(self::COOKIE_DURATION)
                ->setPath('/');
            $this->cookieManager
                ->setPublicCookie(self::POS_ID_COOKIE_NAME, $deviceHash, $metadata);

        } elseif ($this->getRequest()->getParam('visibility') != NULL) {

            $enableRequest = $this->getRequest()->getParam('visibility');
            if ($enableRequest == 1) {
                $cookieValue = 1;
            } else {
                $cookieValue = 0;
            }
            $metadata = $this->cookieMetadataFactory
                ->createPublicCookieMetadata()
                ->setDuration(self::COOKIE_DURATION)
                ->setPath('/');
            $this->cookieManager
                ->setPublicCookie(self::POS_VISIBILITY_COOKIE_NAME, $cookieValue, $metadata);

        }
        return $this->_redirect('/');
    }
}